// @TOOD change this file name
<template>
  <div id="card-header-form">
    <button class="btn btn-primary" type="button" @click=on_browse>Przeglądaj</button>

    <input type="text" v-model="card_header_object.number" placeholder="number" />

    <select
      name="handlings_level"
      id="handlings_level"
      v-model="card_header_object.handlings_level"
    >
      <option value="null" disabled>handlings_level</option>
      <option v-for="h_level in handlings_level_list" :key="h_level.id" :value="h_level.id">{{h_level.level}}</option>
    </select>

    <select
      name="air_ship"
      id="air_ship"
      v-model="card_header_object.air_ship"
    >
      <option value="null" disabled>air_ship</option>
      <option v-for="air_ship in air_ship_list" :key="air_ship.id" :value="air_ship.id">{{air_ship.number}}</option>
    </select>

    <input type="date" v-model="card_header_object.start_date" />
    <input type="date" v-model="card_header_object.finish_date" />

    <button @click="CreateCardHeader">{{submit_text}}</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { createDataBaseObject, putDataBaseObject, getCardHeaderById, getHandlingsLevels, getAirships, getExtendedUsersPartial } from "../../utils/apiUtils";
import router from "../../router";

const card_header_url = "http://127.0.0.1:8000/handlings/card_header/";

export default {
  // @TOOD issuer powinien się automatycznie ustawić, jako ten kto dodaje - (tylko ktoś z poziomem admin)
  // @TODO pole ordere - usunąć 
  // @TODO admin powinien mieć móc zakonczyć kartę (dodać button zakończ kartę, i doda sie finish date jako aktualna data)
  // @TODO tylko admin ma dostęp do zakonczonych kart
  name: "CardHeaderCreate",
  props: {
    initial_object : Object,
    id : String,
    after_post_callback : Function,
    on_browse : Function,
  },
  data: function() {
    return {
      card_header_object:{
          number: "",
          issuer: null,
          handlings_level: null,
          air_ship: null,
          man_hours: null,
          start_date: null,
          finish_date: null,
      },

      handlings_level_list: [],
      air_ship_list: [],
      users_list: [],

      submit_text: "Create",
      error_message: ""
    };
  },
  methods: {
    CardHeaderObjectClear() {
        this.card_header_object = {
          number: "",
          issuer: null,
          handlings_level: null,
          air_ship: null,
          man_hours: null,
          start_date: null,
          finish_date: null,
      };
    },
    CreateCardHeader() {
        (async () => {
            try {
              if (this.submit_text == "Create") {
                    this.card_header_object.issuer = this.$store.state.user?.id;
                    console.log("card handling object:", this.card_header_object);
                    await createDataBaseObject(card_header_url, this.card_header_object, "card_header");
                    this.CardHeaderObjectClear();
              } else if (this.submit_text == "Edit") {
                await putDataBaseObject(card_header_url + this.initial_object.id + "/", this.card_header_object, "card_header");
              }
              this.after_post_callback?.();
            } catch (error) {
                this.error_message = error;
            }
        })();
    },
    specChanged() {},
  },

  mounted: function() {
    if (this.initial_object) {
      this.card_header_object = this.initial_object;
      this.submit_text = "Edit";
    }
    else if (this.id) {
      (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.card_header_object = await getCardHeaderById(this.id);
      })();
      this.submit_text = "Edit";
    }

    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.air_ship_list = await getAirships();
        this.handlings_level_list = await getHandlingsLevels();
        this.users_list = await getExtendedUsersPartial();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
#card-header-form {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
select {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>